% Segmenting individual cells from the projection image

function centroids = FindCellsFunc(I1,thres)

mincellsize=9;

sigma=5;

s=size(I1);

f1=fspecial( 'gaussian', [s(1) s(2)], sigma);

% Gaussian smoothing for the segmentation of individual cells
I2 = real(fftshift(ifft2(fft2(I1).*fft2(f1))));

% Gaussian smoothing to identify the area occupied by cellular material

f2=fspecial( 'gaussian', [s(1) s(2)], 10);

Ibackg = real(fftshift(ifft2(fft2(I1).*fft2(f2)))) < thres;

I2=I2.*(1-Ibackg);


Ilabel=findcellsfromregiongrowing(I2, 1, mincellsize);


centroids = round(calculateCellPositions(I2,Ilabel,1));


end
